﻿using System.Collections;
using System;
using UnityEngine;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static string ModTag = " [BH]"; //Whilst not required, modded items should contain 'tags' at the end of their names to prevent errors in which two mods have an item of the same name.
        public static AudioClip syringeSound = ModAPI.LoadSound("sfx/Syringe.mp3");
        public static void Main()
        {
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Morphine" + ModTag,
                DescriptionOverride = "A powerful opiate for treating pain associated with internal injuries, but will cause shortness of breath and eventual death with overuse.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/morphinethumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/morphine.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 0; //morphine
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Fentanyl" + ModTag,
                DescriptionOverride = "A very powerful opiate for treating pain associated with internal injuries, but will cause shortness of breath and eventual death with overuse.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/fentanylthumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/fentanyl.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 1; //morphine
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Opium" + ModTag,
                DescriptionOverride = "A relatively mild opioid. Most commonly used to manufacture morphine and fentanyl.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/opiumthumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/opium.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 2; //morphine
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Velonaceps Calyx Eggs" + ModTag,
                DescriptionOverride = "Dormant eggs of the Europan lifeform colloquially referred to as 'husk parasite'.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/huskinjectthumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/huskinject.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 3; //husk
                }
            });

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Calyxanide" + ModTag,
                DescriptionOverride = "An antiparasitic drug used in the treatment of husk parasite infections. Might require higher dosage to cure the infection at later stages.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/calyxanidethumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/calyxanide.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 4; //unhusk
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Deusizine" + ModTag,
                DescriptionOverride = "A highly potent stimulant effective in the treatment of internal damage, oxygen deprivation and, to a lesser extent, blood loss. Produces mild burns as a side effect.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/deusthumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/deus.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 5; //special shit
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Broad-spectrum antibiotics" + ModTag,
                DescriptionOverride = "A mild antibiotic that acts against a wide range of disease-causing bacteria, though with the side effect of minor organ damage. Used as an ingredient in many medical compounds.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/antibioticthumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/antibiotic.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 6; //special shit
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Methamphetamine " + ModTag,
                DescriptionOverride = "A potent nervous system stimulant.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/meththumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/meth.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 7; //special shit
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Paralyzant " + ModTag,
                DescriptionOverride = "Causes paralysis.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/paralyzantthumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/paralyzant.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 8; //special shit
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Anaparalyzant " + ModTag,
                DescriptionOverride = "A cure for paralysis. Beware: Excessive use may cause psychosis.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/anaparalyzantthumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/anaparalyzant.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 9; //special shit
                }
            });
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Morbusine " + ModTag,
                DescriptionOverride = "A highly potent neurotoxin.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/morbusinethumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/morbusine.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 10; //special shit
                }
            });

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Morbusine Antidote " + ModTag,
                DescriptionOverride = "An antidote for acute morbusine poisoning.",
                CategoryOverride = ModAPI.FindCategory("Chemistry"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/morbusineantithumb.png"), //For convienence, it's best to place all sound effects and sprites within the sfx and sprites folder that comes with this base.
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/morbusineanti.png");
                    Instance.FixColliders();
                    Instance.AddComponent<Injectable>().injtype = 11; //special shit
                }
            });
        }
    }
    public class Injectable : MonoBehaviour
    {
        public int injtype;
        float disstime = 1.5f;
        bool used;
        void OnCollisionEnter2D(Collision2D collision)
        {
            if (collision.collider.GetComponent<LimbBehaviour>() && !used && !collision.collider.GetComponent<LimbBehaviour>().IsAndroid && Vector2.Dot((Vector2)transform.up, (collision.GetContact(0).point - (Vector2)transform.position).normalized) > 0)
            {
                used = true;
                Destroy(GetComponent<BoxCollider2D>());
                FixedJoint2D joint = gameObject.AddComponent<FixedJoint2D>();
                joint.connectedBody = collision.rigidbody;
                GetComponent<PhysicalBehaviour>().PlayClipOnce(Mod.syringeSound);
            }
        }
        void Update()
        {
            if (used)
            {
                disstime -= Time.deltaTime;
                if (disstime < 0)
                {
                    ModAPI.CreateParticleEffect("Disintegration", transform.position);
                    Destroy(gameObject);
                    switch (injtype)
                    {
                        case 0:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<OpiatePerson>().strength += 25f;
                            break;
                        case 1:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<OpiatePerson>().strength += 50f;
                            break;
                        case 2:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<OpiatePerson>().strength += 10f;
                            break;
                        case 3:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<HuskParasite>().strength += 1f;
                            break;
                        case 4:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<HuskParasite>().strength -= 40f;
                            break;
                        case 5:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.OxygenLevel += 0.2f;
                            foreach (LimbBehaviour limb in GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.Limbs)
                            {
                                limb.Health = Mathf.Lerp(limb.Health, limb.InitialHealth, 0.2f);
                                limb.PhysicalBehaviour.BurnProgress += 0.01f;
                            }
                            break;
                        case 6:
                            if (GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.TryGetComponent(out HuskParasite husk))
                            {
                                husk.strength -= 15f;
                            }
                            foreach (LimbBehaviour limb in GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.Limbs)
                            {
                                limb.Health = Mathf.Lerp(limb.Health, 0, 0.1f);
                            }
                            break;
                        case 7:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.OxygenLevel += 0.1f;
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.Consciousness += 0.5f;
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.AdrenalineLevel += 20f;
                            foreach (LimbBehaviour limb in GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.Limbs)
                            {
                                limb.Health = Mathf.Lerp(limb.Health, 0, 0.1f);
                            }
                            break;
                        case 8:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<Paralyzant>().strength += 1f;
                            break;
                        case 9:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<Paralyzant>().strength -= 50f;
                            break;
                        case 10:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<Morbusine>().strength += 1f;
                            break;
                        case 11:
                            GetComponent<FixedJoint2D>().connectedBody.GetComponent<LimbBehaviour>().Person.gameObject.GetOrAddComponent<Morbusine>().strength -= 50f;
                            break;
                    }
                }
            }
        }
    }
    public class OpiatePerson : MonoBehaviour
    {
        public float strength = 1f;
        PersonBehaviour person;
        void Start()
        {
            person = GetComponent<PersonBehaviour>();
        }
        void Update()
        {
            strength -= Time.deltaTime * 0.4f;
            //limit oxygen levels based on strength
            if (person.OxygenLevel > 1f - strength * 0.01f)
            {
                person.OxygenLevel = 1f - strength * 0.01f - 0.1f;
            }
            if (strength > 20f)
            {
                person.ShockLevel = 0f;
                person.PainLevel = 0f;
            }
            if (strength < 0f) Destroy(this);
            //disable all pain, shock, and give adrenaline above 20
        }
    }
    public class HuskParasite : MonoBehaviour
    {
        public float strength = 1f;
        PersonBehaviour person;
        GameObject mouthStick;
        bool hasExploded;
        public float spreadTime;
        void Start()
        {
            person = GetComponent<PersonBehaviour>();
        }
        void Update()
        {
            if (!hasExploded)
                person.Wince(100f * Time.deltaTime);
            else { person.PainLevel = 0f; person.ShockLevel = 0f; }
            strength += Time.deltaTime * 0.3f;
            if (strength > 75f)
            {
                person.OxygenLevel = 1f;
                foreach (LimbBehaviour limb in person.Limbs)
                {
                    limb.CirculationBehaviour.HealBleeding();
                    if (hasExploded) limb.Health = Mathf.Lerp(limb.Health, limb.InitialHealth, Time.deltaTime);
                }
                if (!mouthStick)
                {
                    mouthStick = Instantiate(ModAPI.FindSpawnable("Worm Staff").Prefab, person.Limbs[0].transform);
                    mouthStick.transform.localPosition = new Vector3(ModAPI.PixelSize * -23f, ModAPI.PixelSize * -3f, 0f);
                    mouthStick.GetComponent<SpriteRenderer>().enabled = false;
                    mouthStick.transform.localEulerAngles = new Vector3(0f, 0f, -90f);
                    mouthStick.GetComponent<Collider2D>().enabled = false;
                    mouthStick.AddComponent<FixedJoint2D>().connectedBody = person.Limbs[0].PhysicalBehaviour.rigidbody;
                    //mouthStick.GetComponent<Rigidbody2D>().useAutoMass = false;
                    mouthStick.GetComponent<Rigidbody2D>().simulated = false;
                    mouthStick.GetComponent<WormStaffBehaviour>().Range = 0f;
                    person.Limbs[0].SkinMaterialHandler.ShotDamage(10f, person.Limbs[0].transform.position + person.Limbs[0].transform.right * ModAPI.PixelSize * 5f);

                }
                else
                {
                    mouthStick.transform.localPosition = new Vector3(ModAPI.PixelSize * -23f, ModAPI.PixelSize * -3f, 0f);
                }
            }
            if (strength > 97f && !hasExploded)
            {
                person.Wince(1000f * Time.deltaTime);
                person.PainLevel = 1f;
            }
            if (strength > 100f && !hasExploded)
            {
                hasExploded = true;
                person.Limbs[0].SkinMaterialHandler.ShotDamage(75f, person.Limbs[0].transform.position + person.Limbs[0].transform.right * ModAPI.PixelSize * 5f);
                ModAPI.CreateParticleEffect("BloodExplosion", person.Limbs[0].transform.position);
                person.PainLevel = 0f;
            }
            if (strength < 0f)
            {
                Destroy(this);
                if (mouthStick) Destroy(mouthStick);
            }
            spreadTime -= Time.deltaTime;
            if(spreadTime < 0f && strength > 75f)
            {
                spreadTime = 3f;
                Collider2D[] cols = Physics2D.OverlapCircleAll(person.Limbs[0].transform.position, ModAPI.PixelSize * 20f);
                foreach(Collider2D col in cols)
                {
                    if(col.TryGetComponent(out LimbBehaviour limb))
                    {
                        limb.Person.gameObject.GetOrAddComponent<HuskParasite>().strength += 0.1f;
                    }
                }
            }
        }
    }
    public class Paralyzant : MonoBehaviour
    {
        public float strength = 1f;
        PersonBehaviour person;
        void Start()
        {
            person = GetComponent<PersonBehaviour>();
        }
        void Update()
        {
            strength += Time.deltaTime;
            strength = Mathf.Clamp(strength, -1f, 100f);
            foreach (LimbBehaviour limb in person.Limbs)
            {
                if (limb.Numbness < strength * 0.01f) limb.Numbness = strength * 0.01f;
            }
            if (strength < 0f) Destroy(this);
        }
    }
    public class Morbusine : MonoBehaviour
    {
        public float strength = 1f;
        PersonBehaviour person;
        void Start()
        {
            person = GetComponent<PersonBehaviour>();
        }
        void Update()
        {
            strength += Time.deltaTime;
            strength = Mathf.Clamp(strength, -1f, 100f);
            if (person.OxygenLevel > 1f - strength * 0.01f) person.OxygenLevel = 1f - strength * 0.01f;
            foreach (LimbBehaviour limb in person.Limbs)
            {
                if (limb.Numbness < 0.1f) limb.Numbness = 0.1f;
            }
            if (strength < 0f) Destroy(this);
        }
    }
}